<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.1.189">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">


<title>EDoN Secure Research Environment Wiki - Contributing to the Wiki</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1.6em;
  vertical-align: middle;
}
</style>


<script src="../site_libs/quarto-nav/quarto-nav.js"></script>
<script src="../site_libs/clipboard/clipboard.min.js"></script>
<script src="../site_libs/quarto-search/autocomplete.umd.js"></script>
<script src="../site_libs/quarto-search/fuse.min.js"></script>
<script src="../site_libs/quarto-search/quarto-search.js"></script>
<meta name="quarto:offset" content="../">
<link href="../images/EDoN.png" rel="icon" type="image/png">
<script src="../site_libs/quarto-html/quarto.js"></script>
<script src="../site_libs/quarto-html/popper.min.js"></script>
<script src="../site_libs/quarto-html/tippy.umd.min.js"></script>
<script src="../site_libs/quarto-html/anchor.min.js"></script>
<link href="../site_libs/quarto-html/tippy.css" rel="stylesheet">
<link href="../site_libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" id="quarto-text-highlighting-styles">
<script src="../site_libs/bootstrap/bootstrap.min.js"></script>
<link href="../site_libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="../site_libs/bootstrap/bootstrap.min.css" rel="stylesheet" id="quarto-bootstrap" data-mode="light">
<script id="quarto-search-options" type="application/json">{
  "location": "navbar",
  "copy-button": false,
  "collapse-after": 3,
  "panel-placement": "end",
  "type": "overlay",
  "limit": 20,
  "language": {
    "search-no-results-text": "No results",
    "search-matching-documents-text": "matching documents",
    "search-copy-link-title": "Copy link to search",
    "search-hide-matches-text": "Hide additional matches",
    "search-more-match-text": "more match in this document",
    "search-more-matches-text": "more matches in this document",
    "search-clear-button-title": "Clear",
    "search-detached-cancel-button-title": "Cancel",
    "search-submit-button-title": "Submit"
  }
}</script>


<link rel="stylesheet" href="../styles.css">
<meta property="og:title" content="EDoN Secure Research Environment Wiki - Contributing to the Wiki">
<meta property="og:description" content="The way we work inside the SRE will always change - whether that is because we get new data, update software packages or fixing bugs that make the SRE run smoothly.">
<meta property="og:site-name" content="EDoN Secure Research Environment Wiki">
<meta name="twitter:title" content="EDoN Secure Research Environment Wiki - Contributing to the Wiki">
<meta name="twitter:description" content="The way we work inside the SRE will always change - whether that is because we get new data, update software packages or fixing bugs that make the SRE run smoothly.">
<meta name="twitter:card" content="summary">
</head>

<body class="nav-fixed">

<div id="quarto-search-results"></div>
  <header id="quarto-header" class="headroom fixed-top">
    <nav class="navbar navbar-expand-lg navbar-dark ">
      <div class="navbar-container container-fluid">
      <div class="navbar-brand-container">
    <a href="../index.html" class="navbar-brand navbar-brand-logo">
    <img src="../images/EDoN-Logo-Purple-print.jpg" alt="" class="navbar-logo">
    </a>
    <a class="navbar-brand" href="../index.html">
    <span class="navbar-title">EDoN Secure Research Environment Wiki</span>
    </a>
  </div>
          <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation" onclick="if (window.quartoToggleHeadroom) { window.quartoToggleHeadroom(); }">
  <span class="navbar-toggler-icon"></span>
</button>
          <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="navbar-nav navbar-nav-scroll me-auto">
  <li class="nav-item">
    <a class="nav-link" href="../index.html">Home</a>
  </li>  
  <li class="nav-item">
    <a class="nav-link" href="../get-started/index.html">Get Started</a>
  </li>  
  <li class="nav-item">
    <a class="nav-link" href="../datasets/index.html">Datasets</a>
  </li>  
  <li class="nav-item">
    <a class="nav-link" href="../blog/index.qmd">Blog</a>
  </li>  
  <li class="nav-item">
    <a class="nav-link active" href="../wiki/index.html" aria-current="page">Contributing to the Wiki</a>
  </li>  
</ul>
              <div id="quarto-search" class="" title="Search"></div>
          </div> <!-- /navcollapse -->
      </div> <!-- /container-fluid -->
    </nav>
</header>
<!-- content -->
<div id="quarto-content" class="quarto-container page-columns page-rows-contents page-layout-article page-navbar">
<!-- sidebar -->
<!-- margin-sidebar -->
    <div id="quarto-margin-sidebar" class="sidebar margin-sidebar">
        <nav id="TOC" role="doc-toc" class="toc-active">
    <h2 id="toc-title">On this page</h2>
   
  <ul>
  <li><a href="#how-is-the-wiki-built" id="toc-how-is-the-wiki-built" class="nav-link active" data-scroll-target="#how-is-the-wiki-built">How is the Wiki built?</a>
  <ul class="collapse">
  <li><a href="#how-do-i-work-with-quarto-to-edit-the-wiki" id="toc-how-do-i-work-with-quarto-to-edit-the-wiki" class="nav-link" data-scroll-target="#how-do-i-work-with-quarto-to-edit-the-wiki">How do I work with Quarto to edit the Wiki?</a></li>
  <li><a href="#the-_quarto.yml-file" id="toc-the-_quarto.yml-file" class="nav-link" data-scroll-target="#the-_quarto.yml-file">The <code>_quarto.yml</code> file</a></li>
  <li><a href="#markdown-files-created-this-website-for-the-wiki" id="toc-markdown-files-created-this-website-for-the-wiki" class="nav-link" data-scroll-target="#markdown-files-created-this-website-for-the-wiki">Markdown files created this website for the Wiki?</a></li>
  </ul></li>
  <li><a href="#im-getting-the-hang-of-quarto---what-next" id="toc-im-getting-the-hang-of-quarto---what-next" class="nav-link" data-scroll-target="#im-getting-the-hang-of-quarto---what-next">I’m getting the hang of Quarto - what next?</a>
  <ul class="collapse">
  <li><a href="#how-do-i-check-some-changes-before-merging" id="toc-how-do-i-check-some-changes-before-merging" class="nav-link" data-scroll-target="#how-do-i-check-some-changes-before-merging">How do I check some changes before merging?</a></li>
  <li><a href="#what-should-i-change" id="toc-what-should-i-change" class="nav-link" data-scroll-target="#what-should-i-change">What should I change?</a></li>
  <li><a href="#im-unsure-where-to-start---help" id="toc-im-unsure-where-to-start---help" class="nav-link" data-scroll-target="#im-unsure-where-to-start---help">I’m unsure where to start - help!</a></li>
  </ul></li>
  <li><a href="#are-there-any-other-considerations" id="toc-are-there-any-other-considerations" class="nav-link" data-scroll-target="#are-there-any-other-considerations">Are there any other considerations?</a></li>
  </ul>
<div class="toc-actions"><div><i class="bi bi-git"></i></div><div class="action-links"><p><a href="https://gitlab.com/edon-initiative/containers/edon-sre-wiki/edit/main/wiki/index.qmd" class="toc-action">Edit this page</a></p><p><a href="https://gitlab.com/edon-initiative/containers/edon-sre-wiki/issues/new" class="toc-action">Report an issue</a></p></div></div></nav>
    </div>
<!-- main -->
<main class="content" id="quarto-document-content">

<header id="title-block-header" class="quarto-title-block default">
<div class="quarto-title">
<h1 class="title">Contributing to the Wiki</h1>
</div>



<div class="quarto-title-meta">

    
    
  </div>
  

</header>

<p>The way we work inside the SRE will always change - whether that is because we get new data, update software packages or fixing bugs that make the SRE run smoothly. This means the SRE Wiki should change with it to provide up to date documentation for EDoN SRE users. This page provides a guide on how to contribute to maintaining the wiki so that it works for everyone.</p>
<section id="how-is-the-wiki-built" class="level2">
<h2 class="anchored" data-anchor-id="how-is-the-wiki-built">How is the Wiki built?</h2>
<p>The SRE Wiki is built with Quarto - an open-source scientific and technical publishing system built by Posit PBC. Unlike Jupyter Book or RMarkdown, it isn’t a package that belongs to a programming language, it’s a javascript based cli program that supports embedding multple languages within Quarto documents. Part of building and maintaining the Wiki is deciding what tools we use to build it and this might change if we think it’s the best thing to do.</p>
<p>The GitLab code repository for the Wiki is found <a href="https://gitlab.com/edon-initiative/containers/edon-sre-wiki/-/tree/main">here</a>.</p>
<section id="how-do-i-work-with-quarto-to-edit-the-wiki" class="level3">
<h3 class="anchored" data-anchor-id="how-do-i-work-with-quarto-to-edit-the-wiki">How do I work with Quarto to edit the Wiki?</h3>
<p>Working with Quarto is largely working with markdown files. Where GitHub, GitLab, HackMD use vanilla <code>.md</code> markdown files to write README files etc, or R uses <code>.Rmd</code> RMarkdown files to write notebooks and shiny applications, Quarto has it’s own flavour of markdown file called a <code>.qmd</code> file. If you have ever edited a markdown file before, you will be at home with writing markdown files in Quarto - and this is <em>mostly</em> all you need to build this wiki.</p>
</section>
<section id="the-_quarto.yml-file" class="level3">
<h3 class="anchored" data-anchor-id="the-_quarto.yml-file">The <code>_quarto.yml</code> file</h3>
<p>The other important file for this Wiki, and for Quarto in general is the <code>_quarto.yml</code> file. The reason you see links on the navigation bar, or sections on the left sidebar is because they are specified to look that way in the <code>_quarto.yml</code>. This file basically wants the Wiki to be organized into sub-directories, where you tell <code>_quarto.yml</code> where to render and serve each sub-directory. It is common to see an <code>index.qmd</code> file in every subdirectory to act as a landing page for that sub-directory.</p>
<p>The Quarto official documentation can be found at <a href="https://quarto.org/docs/guide/"></a></p>
</section>
<section id="markdown-files-created-this-website-for-the-wiki" class="level3">
<h3 class="anchored" data-anchor-id="markdown-files-created-this-website-for-the-wiki">Markdown files created this website for the Wiki?</h3>
<p><em>Almost</em></p>
<p>GitLab has a feature called <a href="https://docs.gitlab.com/ee/user/project/pages/">GitLab Pages</a> that serves files such as markdown as a static website. In particular the GitLab repository looks for a <code>_gitlab-ci.yml</code> file that gives instructions to build the repository and serve as a website, as well as other jobs such as building a container from a Docker image.</p>
<p>The existing <code>_gitlab-ci.yml</code> file for the Wiki will rarely need to be modified, but it’s worth being aware of to understand how GitLab builds the website for the Wiki.</p>
</section>
</section>
<section id="im-getting-the-hang-of-quarto---what-next" class="level2">
<h2 class="anchored" data-anchor-id="im-getting-the-hang-of-quarto---what-next">I’m getting the hang of Quarto - what next?</h2>
<p>Once you are comfortable editing <code>.qmd</code> files and slotting them into the <code>_quarto.yml</code> file, you can <em>change the way this wiki looks</em> by:</p>
<ul>
<li>Cloning the repository to your local SRE desktop</li>
<li>Create a new branch with <code>git branch mynewbranch</code></li>
<li>Switch to the new branch with <code>git checkout mynewbranch</code></li>
<li>Edit or create a <code>.qmd</code> file(s)</li>
<li>Make changes to the <code>_quarto.yml</code> file (if needed)</li>
<li>Commit your changes with <code>git commit -a -m "change I have made"</code></li>
<li>Push the change to GitLab <code>git push --set-upstream origin mynewbranch</code></li>
</ul>
<p>and by going to the GitLab repository you will see a request to merge your changes via a Merge Request. At this point it is good practice to ask someone to review your changes, and the once happy, Merge into the main branch. This will change the Wiki and by refreshing the Wiki in your browser you will see the change reflected.</p>
<div class="callout-note callout callout-style-default callout-captioned">
<div class="callout-header d-flex align-content-center">
<div class="callout-icon-container">
<i class="callout-icon"></i>
</div>
<div class="callout-caption-container flex-fill">

</div>
</div>
<div class="callout-body-container callout-body">
<p>You can also click on “Edit this page” on the right hand side of this page. This takes you directly to the page on the GitLab website and you can edit directly - don’t forget to create a new branch at the bottom of the page on GitLab when you commit these changes!</p>
</div>
</div>
<section id="how-do-i-check-some-changes-before-merging" class="level3">
<h3 class="anchored" data-anchor-id="how-do-i-check-some-changes-before-merging">How do I check some changes before merging?</h3>
<p>If you want to see the changes before you push to the GitLab repository then as long as you have saved your changes (you don’t need to commit them) - at the top of the local cloned directory you can run <code>quarto preview index.qmd</code> and this will provide you with a <code>localhost</code> URL that you can visit and check your changes. This method is handy if you are reviewing a Merge Request for someone. You could do the folllowing:</p>
<ul>
<li>Clone the repository (if you already haven’t)</li>
<li>Pull the latest changes (if you have) with <code>git pull</code> from within the local directory</li>
<li>Switch to the branch the Merge Request has been created on with <code>git checkout mycoolbranch</code></li>
<li>Run <code>quarto preview index.qmd</code> and you will get a <code>localhost</code> URL that you can visit and see the changes the Reviewee has made. Once you are happy, you can accepted the Merge Request, if not you can make your own edits and push them, or use the conversation section of the Merge Request on GitLab to decide how to move forward.</li>
</ul>
</section>
<section id="what-should-i-change" class="level3">
<h3 class="anchored" data-anchor-id="what-should-i-change">What should I change?</h3>
<p>There are a whole range of ways that can improve and maintain the wiki - here is a very small list to give you an idea:</p>
<ul>
<li>Update with new information i.e.&nbsp;details of a dataset</li>
<li>Update out of date information</li>
<li>Write a new section - perhaps a tutorial on how to better understand something?</li>
<li>Correct typos</li>
<li>Review and Edit Merge Requests</li>
<li>Write a Blog entry on some work you have done</li>
</ul>
</section>
<section id="im-unsure-where-to-start---help" class="level3">
<h3 class="anchored" data-anchor-id="im-unsure-where-to-start---help">I’m unsure where to start - help!</h3>
<p>One way of finding ways to help out is to check the Issues <a href="https://gitlab.com/edon-initiative/containers/edon-sre-wiki/-/issues"></a> board for the Wiki repository. Here you can log ideas to work on together, or bugs that need to be fixed but you don’t have the time or know how. A good, healthy Wiki should have lots of Issues at any one time :)</p>
</section>
</section>
<section id="are-there-any-other-considerations" class="level2">
<h2 class="anchored" data-anchor-id="are-there-any-other-considerations">Are there any other considerations?</h2>
<p><em>Containers!</em></p>
<p>Any project that involves code can get a bit messy, even with version control. One reason is that mutliple collaborators might be using different software locally to someone else. Imagine putting a graph on the Wiki that uses a certain version of <code>matplotlib</code> that might break if someone runs the same code, but with a different version of <code>matplotlib</code> on their machine? We might also be using different versions on the Quarto binary (although perhaps we should co-ordinate that!).</p>
<p>One thing we can do is to try and ensure we are using the same versions of software when we are building and testing the Wiki locally, so that when we push those changes to GitLab, they will always work for someone when they pull to their local machine.</p>
<p><em>This can be really annoying</em> to co-ordinate without any help, especially with a project that uses multiple languages. <code>conda</code> can help you create multi-language <code>virtual environments</code> that can manage package versions for langauges without effecting the main install on your machine. However an even cleaner way is to use Containers - and in our case Docker. A Docker container builds a fresh new Operating System that contains a specific set of software and this container can be shared about and used as any othe operating system. With a <code>.Dockerfile</code> we can specify all of what goes into the container in advance such as the Quarto version, versions of Python/R packages etc.</p>
<p>The Wiki is built from and comes with a Docker container for you to use. You can find the latest container here <a href="https://gitlab.com/edon-initiative/containers/edon-sre-wiki/container_registry/3604254"></a> and the lastest version of the <code>.Dockerfile</code> that built it here <a href="https://gitlab.com/edon-initiative/containers/edon-sre-wiki/-/blob/main/Dockerfile"></a>.</p>
<p>The idea is to run the Docker container on your local machine and edit your local version of Wiki repository from within the Docker container. This way we can ensure that everyone has the same local environment when developing the Wiki. You can find more information on how to run this Wiki’s Docker container in the <a href="../reproducibility/containers/containers.html">Containers section</a>.</p>


</section>

</main> <!-- /main -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const clipboard = new window.ClipboardJS('.code-copy-button', {
    target: function(trigger) {
      return trigger.previousElementSibling;
    }
  });
  clipboard.on('success', function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copied!");
    setTimeout(function() {
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  });
  function tippyHover(el, contentFn) {
    const config = {
      allowHTML: true,
      content: contentFn,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start'
    };
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      return note.innerHTML;
    });
  }
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const cites = ref.parentNode.getAttribute('data-cites').split(' ');
    tippyHover(ref, function() {
      var popup = window.document.createElement('div');
      cites.forEach(function(cite) {
        var citeDiv = window.document.createElement('div');
        citeDiv.classList.add('hanging-indent');
        citeDiv.classList.add('csl-entry');
        var biblioDiv = window.document.getElementById('ref-' + cite);
        if (biblioDiv) {
          citeDiv.innerHTML = biblioDiv.innerHTML;
        }
        popup.appendChild(citeDiv);
      });
      return popup.innerHTML;
    });
  }
});
</script>
</div> <!-- /content -->
<footer class="footer">
  <div class="nav-footer">
    <div class="nav-footer-left">Proudly supported by <a href="https://www.rstudio.com"><img src="https://www.rstudio.com/wp-content/uploads/2018/10/RStudio-Logo-flat.svg" class="img-fluid" alt="RStudio" width="65"></a></div>   
      <div class="nav-footer-center">
        <ul class="footer-items list-unstyled">
    <li class="nav-item">
    <a class="nav-link" href="../about.html">About</a>
  </li>  
</ul>
      </div>
    <div class="nav-footer-right">
      <ul class="footer-items list-unstyled">
    <li class="nav-item compact">
    <a class="nav-link" href="https://github.com/rstudio/vetiver.rstudio.com">
      <i class="bi bi-github" role="img" aria-label="Vetiver site GitHub">
</i> 
    </a>
  </li>  
</ul>
    </div>
  </div>
</footer>



</body></html>